package hu.uw.pallergabor.ble.adparser;

/**
 * Created by paller on 2016.02.01..
 */
public class TypeAddressList extends AdElement {
    public TypeAddressList(int type,byte data[], int pos, int len) {
        this.type = type;
        int items = len / 6;
        addresses = new String[items];
        int ptr = pos;
        for( int i = 0 ; i < items ; ++i ) {
            StringBuffer addr = new StringBuffer();
            addAddrByte( addr,data[ptr],false);
            addAddrByte( addr,data[ptr+1],true);
            addAddrByte( addr,data[ptr+2],true);
            addAddrByte( addr,data[ptr+3],true);
            addAddrByte( addr,data[ptr+4],true);
            addAddrByte( addr,data[ptr+5],true);
            addresses[i] = new String(addr);
            ptr += 6;
        }
    }

    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        switch( type ) {
            case 0x17:
                sb.append( "Public Target Address: ");
                break;

            case 0x18:
                sb.append( "Random Target Address: ");
                break;
        }
        for( int i = 0 ; i < addresses.length ; ++i ) {
            if( i > 0 )
                sb.append(",");
            sb.append( addresses[i]);
        }
        return new String(sb);
    }

    private void addAddrByte( StringBuffer addr,byte addrByte,boolean colonPrefix) {
        int v = ((int)addrByte) & 0xFF;
        if( colonPrefix )
            addr.append(":");
        addr.append(String.format("%02X", v));
    }

    public String[] getAddresses() {
        return addresses;
    }

    String addresses[];
    int type;
}
