package hu.uw.pallergabor.ble.adparser;

/**
 * Created by paller on 2016.02.01..
 */
public class TypeAppearance extends AdElement {
    public TypeAppearance(byte data[], int pos, int len) {
        int v = ((int)data[pos]) & 0xFF;
        if( len > 1 )
            v |= ((((int)data[pos+1]) & 0xFF) << 8 );
        appearance = v;
    }

    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("Appearance: ");
        switch( appearance ) {
            case 0:
                sb.append( "Unknown" );
                break;

            case 64:
                sb.append( "Generic Phone" );
                break;

            case 128:
                sb.append( "Generic Computer" );
                break;

            case 192:
                sb.append( "Generic Watch" );
                break;

            case 193:
                sb.append( "Watch: Sports Watch" );
                break;

            case 256:
                sb.append( "Generic Clock" );
                break;

            case 320:
                sb.append( "Generic Display" );
                break;

            case 384:
                sb.append( "Generic Remote Control" );
                break;

            case 448:
                sb.append( "Generic Eye-glasses" );
                break;

            case 512:
                sb.append( "Generic Tag" );
                break;

            case 576:
                sb.append( "Generic Keyring" );
                break;

            case 640:
                sb.append( "Generic Media Player" );
                break;

            case 704:
                sb.append( "Generic Barcode Scanner" );
                break;

            case 768:
                sb.append( "Generic Thermometer" );
                break;

            case 769:
                sb.append( "Thermometer: Ear" );
                break;

            case 832:
                sb.append( "Generic Heart rate Sensor" );
                break;

            case 833:
                sb.append( "Heart Rate Sensor: Heart Rate Belt" );
                break;

            case 896:
                sb.append( "Generic Blood Pressure" );
                break;

            case 897:
                sb.append( "Blood Pressure: Arm" );
                break;

            case 898:
                sb.append( "Blood Pressure: Wrist" );
                break;

            case 960:
                sb.append( "Human Interface Device (HID)" );
                break;

            case 961:
                sb.append( "Keyboard" );
                break;

            case 962:
                sb.append( "Mouse" );
                break;

            case 963:
                sb.append( "Joystick" );
                break;

            case 964:
                sb.append( "Gamepad" );
                break;

            case 965:
                sb.append( "Digitizer Tablet" );
                break;

            case 966:
                sb.append( "Card Reader" );
                break;

            case 967:
                sb.append( "Digital Pen" );
                break;

            case 968:
                sb.append( "Barcode Scanner" );
                break;

            case 1024:
                sb.append( "Generic Glucose Meter" );
                break;

            case 1088:
                sb.append( "Generic: Running Walking Sensor" );
                break;

            case 1089:
                sb.append( "Running Walking Sensor: In-Shoe" );
                break;

            case 1090:
                sb.append( "Running Walking Sensor: On-Shoe" );
                break;

            case 1091:
                sb.append( "Running Walking Sensor: On-Hip" );
                break;

            case 1152:
                sb.append( "Generic: Cycling" );
                break;

            case 1153:
                sb.append( "Cycling: Cycling Computer" );
                break;

            case 1154:
                sb.append( "Cycling: Speed Sensor" );
                break;

            case 1155:
                sb.append( "Cycling: Cadence Sensor" );
                break;

            case 1156:
                sb.append( "Cycling: Power Sensor" );
                break;

            case 1157:
                sb.append( "Cycling: Speed and Cadence Sensor" );
                break;

            case 3136:
                sb.append( "Generic: Pulse Oximeter" );
                break;

            case 3137:
                sb.append( "Fingertip Pulse Oximeter" );
                break;

            case 3138:
                sb.append( "Wrist Worn Pulse Oximeter" );
                break;

            case 3200:
                sb.append( "Generic: Weight Scale" );
                break;

            case 5184:
                sb.append( "Generic: Outdoor Sports Activity" );
                break;

            case 5185:
                sb.append( "Location Display Device" );
                break;

            case 5186:
                sb.append( "Location and Navigation Display Device" );
                break;

            case 5187:
                sb.append( "Location Pod" );
                break;

            case 5188:
                sb.append( "Location and Navigation Pod" );
                break;

            default:
                sb.append( "Unknown ("+Integer.toString(appearance)+")");
                break;
        }
        return new String(sb);
    }

    int appearance;

}
