package hu.uw.pallergabor.ble.adparser;

/**
 * Created by paller on 2016.02.01..
 */
public class TypeServiceData16BitUUID extends AdElement {
    public TypeServiceData16BitUUID( byte data[], int pos, int len) {
        uuid = -1;
        if (len >= 2) {
            uuid = ((int) data[pos]) & 0xFF;
            uuid |= (((int) data[pos + 1]) & 0xFF) << 8;
            int extdatalen = len - 2;
            extdata = new byte[extdatalen];
            for( int i = 0 ; i < extdatalen ; ++i )
                extdata[i] = data[pos+2+i];
        }
    }

    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append( "Service data: ");
        sb.append( "0x"+hex16(uuid));
        if( extdata.length > 0 ) {
            sb.append(" ");
            for( int i = 0 ; i < extdata.length ; ++i ) {
                if ( i > 0 )
                    sb.append(",");
                sb.append(hex8(extdata[i]));
            }
        }
        return new String(sb);
    }

    public int getUUID() {
        return uuid;
    }
    public byte[] getExtData() { return extdata; }

    int uuid;
    byte extdata[];
}
